

ExplodingTank = {};
mt_explodingTank = {};
mt_explodingTank.__index =ExplodingTank;
explodingTank_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function ExplodingTank:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_explodingTank);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function ExplodingTank:InitializeGameObject( )
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();
	
	self.countdown_timer = 7;
   self.explosionIncrementTimerMAX = 1;   
   self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
   self.explosionSpacing = 0;
   self.widthOrHeightFlag = 0;

end
	
-----------------------------------------------------------------------------------------------------
	
function ExplodingTank:Update( explodingTankPointer )

   self.countdown_timer = self.countdown_timer - 1;
   if( self.countdown_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1);
   end;

	AnimateLuaGameObject( self.cppPointer );

	ExplodingDrawLuaGameObject( self.cppPointer,self.explosionSpacing , self.widthOrHeightFlag );

   self.explosionIncrementTimer = self.explosionIncrementTimer - 1;
   if( self.explosionIncrementTimer <= 0 ) then
      self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
      self.explosionSpacing = self.explosionSpacing + 2;
   end;

--	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------




---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function FindExplodingTankFromPointer (cppPointer )
   return explodingTank_objects[cppPointer] ;
end;


function ExplodingTank_Create(aCppPointer)
   temp = ExplodingTank:new(aCppPointer);
   explodingTank_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function ExplodingTank_Destroy(aCppPointer)
   explodingTank_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------

function ExplodingTank_InitializeGameObject(aCppPointer)
   PrintStringList("Calling ExplodingTank_InitializeGameObject");
   theExplodingTank = explodingTank_objects[aCppPointer];
   theExplodingTank:InitializeGameObject();
end;



---------------------------------------------------------------------------
function ExplodingTank_Update(aCppPointer )
   PrintStringList("Calling ExplodingTank_Update");
   theExplodingTank = explodingTank_objects[aCppPointer];
   theExplodingTank:Update(countdownTimer);
end;


