

FamilyIcon = {};
mt_familyIcon = {};
mt_familyIcon.__index =FamilyIcon;
familyIcon_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function FamilyIcon:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_familyIcon);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function FamilyIcon:InitializeGameObject( )
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();
	
	self.countdown_timer = 30;

end
	
-----------------------------------------------------------------------------------------------------
	
function FamilyIcon:Update( familyIconPointer )

   self.countdown_timer = self.countdown_timer - 1;
   if( self.countdown_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1);
   end;

	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------
function FamilyIcon:PreWaveStartUpdate(  countdownTimer)
--	if countdownTimer <= 70 then
      DrawLuaGameObject( self.cppPointer );
--	end;
end;




---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function FamilyIcon_Create(aCppPointer)
   temp = FamilyIcon:new(aCppPointer);
   familyIcon_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function FamilyIcon_Destroy(aCppPointer)
   familyIcon_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------

function FamilyIcon_InitializeGameObject(aCppPointer)
   PrintStringList("Calling FamilyIcon_InitializeGameObject");
   theFamilyIcon = familyIcon_objects[aCppPointer];
   theFamilyIcon:InitializeGameObject();
end;



---------------------------------------------------------------------------
function FamilyIcon_Update(aCppPointer )
   PrintStringList("Calling FamilyIcon_Update");
   theFamilyIcon = familyIcon_objects[aCppPointer];
   theFamilyIcon:Update(countdownTimer);
end;

function FamilyIcon_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling Electrode_PreWaveStartUpdate");
   theFamilyIcon = familyIcon_objects[aCppPointer];
   theFamilyIcon:PreWaveStartUpdate(countdownTimer);
end;

