

GreenCube = {};
mt_greenCube = {};
mt_greenCube.__index = GreenCube;
greenCube_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------
function GreenCube:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_greenCube);
end;
---------------------------------------------------------------------------




function GreenCube:InitializeGameObject()
--   PrintStringList("Calling GreenCube:InitializeGameObject");
	self.scale = 1;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
    self.collisionBoxWidth = self.bitmapWidth * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


end;

---------------------------------------------------------------------------

function GreenCube:PrepareForWaveStart ()
--   PrintStringList("Calling GreenCube:PrepareForWaveStart");
	SetLuaGameObjectXandY( self.cppPointer, 1, 1 );		

end

---------------------------------------------------------------------------

function GreenCube:PreWaveStartUpdate(  countdownTimer)
end;


function GreenCube:Update( )
--   PrintStringList("Calling GreenCube:Update");
		
	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );

end



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function GreenCube_Create(aCppPointer)
   temp = GreenCube:new(aCppPointer);
   greenCube_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------

function GreenCube_Destroy(aCppPointer)
   greenCube_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------

function GreenCube_InitializeGameObject(aCppPointer)
   theGreenCube = greenCube_objects[aCppPointer];
   theGreenCube:InitializeGameObject();
end;

---------------------------------------------------------------------------

function GreenCube_PrepareForWaveStart(aCppPointer)
   theGreenCube = greenCube_objects[aCppPointer];
   theGreenCube:PrepareForWaveStart();
end;

---------------------------------------------------------------------------

function GreenCube_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling GreenCube_PreWaveStartUpdate");
   theGreenCube = greenCube_objects[aCppPointer];
   theGreenCube:PreWaveStartUpdate(countdownTimer);
end;

---------------------------------------------------------------------------
function GreenCube_Update(aCppPointer )
--   PrintStringList("Calling GreenCube_Update");
   theGreenCube = greenCube_objects[aCppPointer];
   theGreenCube:Update(countdownTimer);
end;




