

TankShot = {};
mt_tankShot = {};
mt_tankShot.__index =TankShot;
tankShot_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function TankShot_Create(aCppPointer)
   temp = TankShot:new(aCppPointer);
   tankShot_objects[aCppPointer] = temp;
end;
---------------------------------------------------------------------------
function TankShot:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_tankShot);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function TankShot:InitializeGameObject( )
	self.scale = 2;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


	self.shot_removal_timer = 140;
end
	
-----------------------------------------------------------------------------------------------------
	
function TankShot:Update( tankShotPointer )


	self.xv, self.yv  = GetLuaGameObjectXVAndYV(self.cppPointer);
	self.collisionBoxX, self.collisionBoxY  = GetLuaGameObjectCollisionBoxXAndY(self.cppPointer );		

	self.x,self.y  = GetLuaGameObjectXAndY(self.cppPointer);
   self.collisionBoxWidth, self.collisionBoxHeight = GetLuaGameObjectCollisionBoxInfo( self.cppPointer );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


	self.shot_removal_timer = self.shot_removal_timer - 1;

	if( self.shot_removal_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1 );
   end;





	if( WasCollisionWithLeftRightWall(self)) then
		self.xv = -self.xv;
   end;

	if( WasCollisionWithUpDownWall(self)) then
		self.yv = -self.yv;
   end;


	self.x = self.x + self.xv;
	self.y = self.y + self.yv;


	SetLuaGameObjectXandY( self.cppPointer, self.x, self.y );
   SetLuaGameObjectXVAndYV( self.cppPointer, self.xv, self.yv );
		
	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------

	function PrepareForWaveStart ( tankShotPointer )
		SetLuaGameObjectXandY( tankShotPointer, 50, 50 );		
	end



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------

function TankShot_Create(aCppPointer)
   temp = TankShot:new(aCppPointer);
   tankShot_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------

function TankShot_Destroy(aCppPointer)
   tankShot_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------


function TankShot_InitializeGameObject(aCppPointer)
   PrintStringList("Calling TankShot_InitializeGameObject");
   theTankShot = tankShot_objects[aCppPointer];
   theTankShot:InitializeGameObject();
end;

---------------------------------------------------------------------------
function TankShot_Update(aCppPointer )
   PrintStringList("Calling TankShot_Update");
   theTankShot = tankShot_objects[aCppPointer];
   theTankShot:Update(countdownTimer);
end;


