

function   AddStandardRemoveOnWaveEndTypes(waveNumber)
	AddRemoveOnWaveEndType(waveNumber, PLAYER_SHOT_TYPE );
	AddRemoveOnWaveEndType(waveNumber, BIRD_TYPE );	
	AddRemoveOnWaveEndType(waveNumber, BIRD_SHOT_TYPE );
	AddRemoveOnWaveEndType(waveNumber, TANK_SHOT_TYPE );
	AddRemoveOnWaveEndType(waveNumber, PROG_TYPE );
	AddRemoveOnWaveEndType(waveNumber, FAMILY_ICON_TYPE );
	AddRemoveOnWaveEndType(waveNumber, BRAIN_SHOT_TYPE );
	AddRemoveOnWaveEndType(waveNumber, TANK_SHOT_TYPE );
	AddRemoveOnWaveEndType(waveNumber, EXPLODING_GRUNT_TYPE );
	AddRemoveOnWaveEndType(waveNumber, EXPLODING_BRAIN_TYPE );
	AddRemoveOnWaveEndType(waveNumber, EXPLODING_TANK_TYPE );
	AddRemoveOnWaveEndType(waveNumber, EXPLODING_BIRD_TYPE );

end;

---------------------------------------------------------		

function AddStandardMustKillTypes(waveNumber)
	AddMustKillType(waveNumber, GRUNT_TYPE);
	AddMustKillType(waveNumber, BIRD_TYPE);
	AddMustKillType(waveNumber, CIRCLE_TYPE);
	AddMustKillType(waveNumber, SQUARE_TYPE);
	AddMustKillType(waveNumber, TANK_TYPE);
	AddMustKillType(waveNumber, BRAIN_TYPE);
	AddMustKillType(waveNumber, TRIANGLE_TYPE);

end;

---------------------------------------------------------		
function SetupWaveOne()

   local waveNumber = AddWave();

   AddWaveElement(waveNumber, ELECTRODE_TYPE_1, 5);

   AddWaveElement(waveNumber, GRUNT_TYPE, 15);
   AddWaveElement(waveNumber, MAN_TYPE, 1);
   AddWaveElement(waveNumber, WOMAN_TYPE, 1);

   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);

end;

---------------------------------------------------------		

function SetupWaveTwo()
   local waveNumber = AddWave();

   AddWaveElement(waveNumber, MAN_TYPE, 1);
   AddWaveElement(waveNumber, WOMAN_TYPE, 1);
   AddWaveElement(waveNumber, MIKEY_TYPE, 1);

   AddWaveElement(waveNumber, GRUNT_TYPE, 17 );
   AddWaveElement(waveNumber, HULK_TYPE, 4 );
   AddWaveElement(waveNumber, CIRCLE_TYPE, 1 );
   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 15);

   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber)

end;





---------------------------------------------------------		

function SetupWaveThree()
	AddWave();


   AddWaveElement(3, MAN_TYPE, 2);
   AddWaveElement(3, WOMAN_TYPE, 2);
   AddWaveElement(3, MIKEY_TYPE, 1);


	AddWaveElement(3, GRUNT_TYPE, 22 );
	AddWaveElement(3, HULK_TYPE,5 );
   AddWaveElement(3, CIRCLE_TYPE, 3 );
   AddWaveElement(3, ELECTRODE_TYPE_2, 24);


   AddStandardRemoveOnWaveEndTypes(3);
   AddStandardMustKillTypes(3)


end;


---------------------------------------------------------		


function SetupWaveFour()
	AddWave();

   local waveNumber = 4;

	AddWaveElement(waveNumber, GRUNT_TYPE, 34 );
	AddWaveElement(waveNumber, HULK_TYPE,5 );


   AddWaveElement(waveNumber, MAN_TYPE, 2);
   AddWaveElement(waveNumber, WOMAN_TYPE, 2);
   AddWaveElement(waveNumber, MIKEY_TYPE, 2);




   AddWaveElement(waveNumber, CIRCLE_TYPE, 4 );
   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 25);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;


---------------------------------------------------------		
function  SetupWave5()
	AddWave();

   local waveNumber = 5;

	AddWaveElement(waveNumber, GRUNT_TYPE, 20 );

   AddWaveElement(waveNumber, WOMAN_TYPE,16);

   AddWaveElement(waveNumber, CIRCLE_TYPE, 1 );
   AddWaveElement(waveNumber, BRAIN_TYPE, 15 );

   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 20);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;

---------------------------------------------------------		


function SetupWave6()
   local waveNumber = AddWave();
   SetIsCompoundWave(waveNumber, 1);
   AddWaveElement(waveNumber, CIRCLE_TYPE, 1 );
--   AddWaveElement(2, SQUARE_TYPE, 1 );   
   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber)


end;


function  SetupWave7()


   local waveNumber = AddWave();

	AddWaveElement(waveNumber, GRUNT_TYPE, 28 );
	AddWaveElement(waveNumber, HULK_TYPE,6 );

   AddWaveElement(waveNumber, MAN_TYPE, 3);
   AddWaveElement(waveNumber, WOMAN_TYPE,3);
   AddWaveElement(waveNumber, MIKEY_TYPE, 3);

   AddWaveElement(waveNumber, CIRCLE_TYPE, 3 );


   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 21);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;

---------------------------------------------------------		

function  SetupWave8()
	

   local waveNumber = AddWave();

--	AddWaveElement(waveNumber, GRUNT_TYPE, 28 );
	AddWaveElement(waveNumber, HULK_TYPE,11 );

   AddWaveElement(waveNumber, MAN_TYPE, 4);
   AddWaveElement(waveNumber, WOMAN_TYPE,4);
   AddWaveElement(waveNumber, MIKEY_TYPE, 4);

--   AddWaveElement(waveNumber, CIRCLE_TYPE, 3 );

   AddWaveElement(waveNumber, SQUARE_TYPE,10 );


--   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 21);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;

---------------------------------------------------------		


function  SetupWave9()
	

   local waveNumber = AddWave();

	AddWaveElement(waveNumber, GRUNT_TYPE, 34 );
	AddWaveElement(waveNumber, HULK_TYPE,6 );

   AddWaveElement(waveNumber, MAN_TYPE, 3);
   AddWaveElement(waveNumber, WOMAN_TYPE,3);
   AddWaveElement(waveNumber, MIKEY_TYPE, 3);

   AddWaveElement(waveNumber, CIRCLE_TYPE, 5 );

--   AddWaveElement(waveNumber, SQUARE_TYPE,10 );


   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 24);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;

---------------------------------------------------------		

function  SetupWave10()
	

   local waveNumber = AddWave();

	AddWaveElement(waveNumber, GRUNT_TYPE, 60 );
	AddWaveElement(waveNumber, HULK_TYPE,4 );

   AddWaveElement(waveNumber, MAN_TYPE, 3);
   AddWaveElement(waveNumber, WOMAN_TYPE,4);
   AddWaveElement(waveNumber, MIKEY_TYPE, 3);

   AddWaveElement(waveNumber, CIRCLE_TYPE, 5 );

--   AddWaveElement(waveNumber, SQUARE_TYPE,10 );


--   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 24);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;

---------------------------------------------------------		

function  SetupWave11()
	

   local waveNumber = AddWave();

	AddWaveElement(waveNumber, GRUNT_TYPE, 25 );
--	AddWaveElement(waveNumber, HULK_TYPE,4 );

--   AddWaveElement(waveNumber, MAN_TYPE, 3);
   AddWaveElement(waveNumber, WOMAN_TYPE,22);
--   AddWaveElement(waveNumber, MIKEY_TYPE, 3);

--   AddWaveElement(waveNumber, CIRCLE_TYPE, 0 );

--   AddWaveElement(waveNumber, SQUARE_TYPE,10 );

   AddWaveElement(waveNumber, BRAIN_TYPE,20 );


   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 20);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;
---------------------------------------------------------		

function SetupWave12()
   local waveNumber = AddWave();
   SetIsCompoundWave(waveNumber, 1);
--   AddWaveElement(waveNumber, CIRCLE_TYPE, 1 );
   AddWaveElement(waveNumber, SQUARE_TYPE, 1 );   
   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber)


end;


function  SetupWave13()
	

   local waveNumber = AddWave();

   AddWaveElement(waveNumber, GRUNT_TYPE, 34 );
   AddWaveElement(waveNumber, HULK_TYPE,5 );

   AddWaveElement(waveNumber, MAN_TYPE, 3);
   AddWaveElement(waveNumber, WOMAN_TYPE,3);
   AddWaveElement(waveNumber, MIKEY_TYPE, 3);

   AddWaveElement(waveNumber, CIRCLE_TYPE, 3 );

   AddWaveElement(waveNumber, SQUARE_TYPE,3 );


   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 24);


   AddStandardRemoveOnWaveEndTypes(waveNumber);
   AddStandardMustKillTypes(waveNumber);


end;


---------------------------------------------------------		

function SetupTestWave()
	

   local waveNumber = AddWave();

--	AddWaveElement(waveNumber, GRUNT_TYPE, 20 );


--   AddWaveElement(waveNumber, GREEN_CUBE_TYPE,1);

--   AddWaveElement(waveNumber, WOMAN_TYPE,1);
--   AddWaveElement(waveNumber, MAN_TYPE,1);
--   AddWaveElement(waveNumber, MIKEY_TYPE,1);


   AddWaveElement(waveNumber, HULK_TYPE, 3 );
--   AddWaveElement(waveNumber, CIRCLE_TYPE, 1 );
--   AddWaveElement(waveNumber, SQUARE_TYPE, 2 );
--   AddWaveElement(waveNumber, TRIANGLE_TYPE, 5 );
--   AddWaveElement(waveNumber, BRAIN_TYPE, 5 );
--   AddWaveElement(waveNumber, TANK_TYPE, 15 );

--   AddWaveElement(waveNumber, ELECTRODE_TYPE_1, 1);
--   AddWaveElement(waveNumber, ELECTRODE_TYPE_2, 1);

--   AddWaveElement(waveNumber, TAD_HEAD_TYPE, 2);


--   AddStandardRemoveOnWaveEndTypes(waveNumber);
--   AddStandardMustKillTypes(waveNumber);


	AddMustKillType(waveNumber, HULK_TYPE,1);


end;


function SetupRealWaves()
   SetupWaveOne();
   SetupWaveTwo();
   SetupWaveThree();
   SetupWaveFour();
   SetupWave5();
   SetupWave6();
   SetupWave7();
   SetupWave8();
   SetupWave9();
   SetupWave10();
   SetupWave11();
   SetupWave12();   
   SetupWave13();      
   

end;

---------------------------------------------------------		

function InitializeWaves()
--   SetupTestWave();

   SetupRealWaves();


end;
