

ExplodingGrunt = {};
mt_explodingGrunt = {};
mt_explodingGrunt.__index =ExplodingGrunt;
explodingGrunt_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function ExplodingGrunt:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_explodingGrunt);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function ExplodingGrunt:InitializeGameObject( )
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();
	
	self.countdown_timer = 7;
   self.explosionIncrementTimerMAX = 1;   
   self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
   self.explosionSpacing = 0;
   self.widthOrHeightFlag = 0;

end
	
-----------------------------------------------------------------------------------------------------
	
function ExplodingGrunt:Update( explodingGruntPointer )

   self.countdown_timer = self.countdown_timer - 1;
   if( self.countdown_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1);
   end;

	AnimateLuaGameObject( self.cppPointer );

	ExplodingDrawLuaGameObject( self.cppPointer,self.explosionSpacing , self.widthOrHeightFlag );

   self.explosionIncrementTimer = self.explosionIncrementTimer - 1;
   if( self.explosionIncrementTimer <= 0 ) then
      self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
      self.explosionSpacing = self.explosionSpacing + 2;
   end;

   --DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------




---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function FindExplodingGruntFromPointer (cppPointer )
   return explodingGrunt_objects[cppPointer] ;
end;


function ExplodingGrunt_Create(aCppPointer)
   temp = ExplodingGrunt:new(aCppPointer);
   explodingGrunt_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function ExplodingGrunt_Destroy(aCppPointer)
   explodingGrunt_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------

function ExplodingGrunt_InitializeGameObject(aCppPointer)
   PrintStringList("Calling ExplodingGrunt_InitializeGameObject");
   theExplodingGrunt = explodingGrunt_objects[aCppPointer];
   theExplodingGrunt:InitializeGameObject();
end;



---------------------------------------------------------------------------
function ExplodingGrunt_Update(aCppPointer )
   PrintStringList("Calling ExplodingGrunt_Update");
   theExplodingGrunt = explodingGrunt_objects[aCppPointer];
   theExplodingGrunt:Update(countdownTimer);
end;


