

PLAYER_TYPE = 0;
ELECTRODE_TYPE_1 = 1;
ELECTRODE_TYPE_2 = 2;
BIRD_SHOT_TYPE = 3;
TANK_SHOT_TYPE =4;
HULK_TYPE = 5;
WOMAN_TYPE = 6;
FAMILY_ICON_TYPE = 7;
CIRCLE_TYPE = 8;
BIRD_TYPE = 9;
TANK_TYPE = 10 ;
SQUARE_TYPE = 11;
BRAIN_TYPE = 12;
PROG_TYPE = 13;
BRAIN_SHOT_TYPE = 14;
ELECTRODE_TYPE = 15;
MAN_TYPE = 16;
FAMILY_MEMBER_TYPE = 17;
GRUNT_TYPE = 18;
MIKEY_TYPE = 19;
EXPLODING_GRUNT_TYPE = 20;
EXPLODING_BRAIN_TYPE = 21;
EXPLODING_HULK_TYPE = 22;
EXPLODING_TANK_TYPE = 23;
TRIANGLE_TYPE = 24;
TAD_HEAD_TYPE = 25;
EXPLODING_BIRD_TYPE = 26;
GREEN_CUBE_TYPE = 27;

PLAYER_SHOT_TYPE = 50;
PLAYER_SHIELD_TYPE = 51;







function InitializeLuaGameTypeDescriptors()


	InitializeLuaGameTypeDescriptor(
			"GreenCube",
			GREEN_CUBE_TYPE,
			"GreenCube.bmp", -- Bitmap filename
			"GreenCube.lua",
			123,  -- width
			127, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);



	InitializeLuaGameTypeDescriptor(
			"Electrode",
			ELECTRODE_TYPE, -- Circle type
			"Electrode.bmp", -- Bitmap filename
			"Electrode.lua",
			18,  -- width
			18, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"TadHead",
			TAD_HEAD_TYPE, -- Circle type
			"TadHead.bmp", -- Bitmap filename
			"TadHead.lua",
			43,  -- width
			46, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);



	InitializeLuaGameTypeDescriptor(
			"ElectrodeType1",
			ELECTRODE_TYPE_1, -- Circle type
			"Electrode1Sprite.bmp", -- Bitmap filename
			"ElectrodeType1.lua",
--			18,  -- width
--			18, -- height
			26,  -- width
			26, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"ElectrodeType2",
			ELECTRODE_TYPE_2, -- Circle type
			"Electrode1Sprite.bmp", -- Bitmap filename
			"ElectrodeType2.lua",
			26,  -- width
			26, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);



	InitializeLuaGameTypeDescriptor(
			"FamilyMember",
			FAMILY_MEMBER_TYPE, -- Circle type
			"Woman.BMP", -- Bitmap filename
			"FamilyMember.lua",
			14,  -- width
			28, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"Grunt",
			GRUNT_TYPE, 
			"NewGruntSprite3.bmp",
			"grunt.lua",
--			18,  -- width
--			26, -- height
			29,  -- width
			34, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 0 2" -- animations
		);



	InitializeLuaGameTypeDescriptor(
			"ExplodingGrunt",
			EXPLODING_GRUNT_TYPE, 
			"NewGruntSprite3.bmp",
			"ExplodingGrunt.lua",
--			18,  -- width
--			26, -- height
			29,  -- width
			34, -- height
			3, -- actual frames per row
			3, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 2" -- animations
		);

		
---------------------------------------------------------
--	InitializeLuaGameTypeDescriptor(
--			"Circle",
--			CIRCLE_TYPE, -- Circle type
--			"Circle.bmp", -- Bitmap filename
--			"circle.lua",
--			22,  -- width
--			22, -- height
--			6, -- actual frames per row
--			6, -- int aNum_frames_per_animation
--			1, --int aNum_animations
--			"0 1 2 3 4 5" -- animations
--		);



	InitializeLuaGameTypeDescriptor(
			"Circle",
			CIRCLE_TYPE, -- Circle type
			"RedSphereSprites3.bmp", -- Bitmap filename
			"circle.lua",
			31,  -- width
			32, -- height
			6, -- actual frames per row
			6, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 2 3 4 5" -- animations
		);


---------------------------------------------------------		


	InitializeLuaGameTypeDescriptor(
			"PlayerShot",
			PLAYER_SHOT_TYPE, -- Player Shot type
			"PlayerShot.bmp", -- Bitmap filename
			"PlayerShot.lua",
			9,  -- width
			9, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			4, --int aNum_animations
			"0" -- animations
		);

---------------------------------------------------------		
		

	InitializeLuaGameTypeDescriptor(
			"Bird",
			BIRD_TYPE, -- Bird type
			"BirdSprite.bmp", -- Bitmap filename
			"Bird.lua",
			31,  -- width
			37, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"ExplodingBird",
			EXPLODING_BIRD_TYPE, -- Bird type
			"BirdSprite.bmp", -- Bitmap filename
			"ExplodingBird.lua",
			31,  -- width
			37, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);


---------------------------------------------------------		


	InitializeLuaGameTypeDescriptor(
			"BirdShot",
			BIRD_SHOT_TYPE, -- BirdShot type
			"BirdShot.bmp", -- Bitmap filename
			"BirdShot.lua",
			14,  -- width
			14, -- height
			2, -- actual frames per row
			2, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1" -- animations
		);

---------------------------------------------------------		

	InitializeLuaGameTypeDescriptor(
			"Square",
			SQUARE_TYPE, -- Circle type
			"Cubes2.bmp", -- Bitmap filename

			"Square.lua",
			36,  -- width
			34, -- height
			4, -- actual frames per row
			4, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 2 3" -- animations
		);



	InitializeLuaGameTypeDescriptor(
			"Triangle",
			TRIANGLE_TYPE, -- Circle type
			"Triangle.bmp", -- Bitmap filename
			"Triangle.lua",
			27,  -- width
			26, -- height
			5, -- actual frames per row
			5, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 2 3 4" -- animations
		);


---------------------------------------------------------		

	InitializeLuaGameTypeDescriptor(
			"Tank",
			TANK_TYPE, -- Circle type
			"Tank.BMP", -- Bitmap filename
			"Tank.lua",
			26,  -- width
			32, -- height
			4, -- actual frames per row
			4, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 2 3" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"ExplodingTank",
			EXPLODING_TANK_TYPE, -- Circle type
			"Tank.BMP", -- Bitmap filename
			"ExplodingTank.lua",
			26,  -- width
			32, -- height
			4, -- actual frames per row
			4, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0 1 2 3" -- animations
		);




	InitializeLuaGameTypeDescriptor(
			"TankShot",
			TANK_SHOT_TYPE, -- Circle type
			"TankShot.BMP", -- Bitmap filename
			"TankShot.lua",
			7,  -- width
			7, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"Woman",
			WOMAN_TYPE, -- Circle type
			"Woman.BMP", -- Bitmap filename
			"Woman.lua",
			14,  -- width
			28, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);





	InitializeLuaGameTypeDescriptor(
			"Man",
			MAN_TYPE, -- Circle type
			"ManSp.bmp", -- Bitmap filename
			"Man.lua",
			16,  -- width
			26, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);





	InitializeLuaGameTypeDescriptor(
			"FamilyIcon",
			FAMILY_ICON_TYPE, -- Circle type
			"FamilyIcon.BMP", -- Bitmap filename
			"FamilyIcon.lua",
			22,  -- width
			22, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			6, --int aNum_animations
			"0" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"Brain",
			BRAIN_TYPE, -- Circle type
			"Brain.bmp", -- Bitmap filename
			"Brain.lua",
			26,  -- width
			32, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"ExplodingBrain",
			EXPLODING_BRAIN_TYPE, -- Circle type
			"Brain.bmp", -- Bitmap filename
			"ExplodingBrain.lua",
			26,  -- width
			32, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"Prog",
			PROG_TYPE, -- Circle type
			"Prog.BMP", -- Bitmap filename
			"Prog.lua",
			7,  -- width
			14, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);


	InitializeLuaGameTypeDescriptor(
			"BrainShot",
			BRAIN_SHOT_TYPE, -- Circle type
			"Prog.BMP", -- Bitmap filename
			"BrainShot.lua",
			3,  -- width
			3, -- height
			1, -- actual frames per row
			1, -- int aNum_frames_per_animation
			1, --int aNum_animations
			"0" -- animations
		);



--	InitializeLuaGameTypeDescriptor(
--			"Hulk",
--			HULK_TYPE, -- Circle type
--			"Hulk.BMP", -- Bitmap filename
--			"Hulk.lua",
--			26,  -- width
--			32, -- height
--			3, -- actual frames per row
--			4, -- int aNum_frames_per_animation
--			8, --int aNum_animations
--			"0 1 0  2" -- animations
--		);


	InitializeLuaGameTypeDescriptor(
			"Hulk",
			HULK_TYPE, -- Circle type
			"HulkSprites.bmp", -- Bitmap filename
			"Hulk.lua",
--			27,  -- width
--			33, -- height
			49,  -- width
			51, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);



	InitializeLuaGameTypeDescriptor(
			"ExplodingHulk",
			EXPLODING_HULK_TYPE, -- Circle type
			"HulkSprites.BMP", -- Bitmap filename
			"ExplodingHulk.lua",
			26,  -- width
			32, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0  2" -- animations
		);




	InitializeLuaGameTypeDescriptor(
			"Mikey",
			MIKEY_TYPE, -- Circle type
			"Mikey.bmp", -- Bitmap filename
			"Mikey.lua",
			10,  -- width
			22, -- height
			3, -- actual frames per row
			4, -- int aNum_frames_per_animation
			8, --int aNum_animations
			"0 1 0 2" -- animations
		);




---------------------------------------------------------		

		
end
